package de.uks.pmws1112.hexentanz.model;

public class Dice
{
   /**
    * <pre>
    *           0..1     dice     0..1
    * Dice ------------------------- Game
    *           dice               game
    * </pre>
    */
   public static final String PROPERTY_GAME = "game";

   private HexentanzGame game;

   public boolean setGame (HexentanzGame value)
   {
      boolean changed = false;

      if (this.game != value)
      {
      
         HexentanzGame oldValue = this.game;
         Dice source = this;
         if (this.game != null)
         {
            this.game = null;
            oldValue.setDice (null);
         }
         this.game = value;

         if (value != null)
         {
            value.setDice (source);
         }
         changed = true;
      }
      return changed;
   }

   public Dice withGame (HexentanzGame value)
   {
      setGame (value);
      return this;
   }

   public HexentanzGame getGame ()
   {
      return this.game;
   }

   public static final String PROPERTY_PIPS = "pips";

   private int pips;

   public void setPips (int value)
   {
      if ( this.pips != value )
      {
         int oldValue = this.pips;
         this.pips = value;
      }
   }

   public Dice withPips (int value)
   {
      setPips (value);
      return this;
   }

   public int getPips ()
   {
      return this.pips;
   }

   /**
    * <pre>
    *           0..1     dice     0..1
    * Dice ------------------------- Player
    *           dice               player
    * </pre>
    */
   public static final String PROPERTY_PLAYER = "player";

   private Player player;

   public boolean setPlayer (Player value)
   {
      boolean changed = false;

      if (this.player != value)
      {
      
         Player oldValue = this.player;
         Dice source = this;
         if (this.player != null)
         {
            this.player = null;
            oldValue.setDice (null);
         }
         this.player = value;

         if (value != null)
         {
            value.setDice (source);
         }
         changed = true;
      
      }
      return changed;
   }

   public Dice withPlayer (Player value)
   {
      setPlayer (value);
      return this;
   }

   public Player getPlayer ()
   {
      return this.player;
   }

   public void removeYou()
   {
      this.setGame (null);
      this.setPlayer (null);
   }
   
   public void roll ()
   {
	   //TODO nicht relevant fr Hausaufgabe 4
   }
}


