package de.uks.pmws1112.hexentanz.model;

public class FinalField extends Field
{
   /**
    * <pre>
    *           0..1     finalGate     0..1
    * FinalField ------------------------- Field
    *           finalGate               finalGateRev
    * </pre>
    */
   public static final String PROPERTY_FINAL_GATE_REV = "finalGateRev";

   private Field finalGateRev;

   public boolean setFinalGateRev (Field value)
   {
      boolean changed = false;

      if (this.finalGateRev != value)
      {
      
         Field oldValue = this.finalGateRev;
         FinalField source = this;
         if (this.finalGateRev != null)
         {
            this.finalGateRev = null;
            oldValue.setFinalGate (null);
         }
         this.finalGateRev = value;

         if (value != null)
         {
            value.setFinalGate (source);
         }
         changed = true;
      
      }
      return changed;
   }

   public FinalField withFinalGateRev (Field value)
   {
      setFinalGateRev (value);
      return this;
   }

   public Field getFinalGateRev ()
   {
      return this.finalGateRev;
   }

   public void removeYou()
   {
      this.setFinalGateRev (null);
      super.removeYou ();
   }
}


