package de.uks.pmws1112.hexentanz.model;

public class HomeField extends Field
{
   /**
    * <pre>
    *           0..*     startField     0..1
    * HomeField ------------------------- StartField
    *           homeField               startField
    * </pre>
    */
   public static final String PROPERTY_START_FIELD = "startField";

   private StartField startField;

   public boolean setStartField (StartField value)
   {
      boolean changed = false;

      if (this.startField != value)
      {
      
         StartField oldValue = this.startField;
         HomeField source = this;
         if (this.startField != null)
         {
            this.startField = null;
            oldValue.removeFromHomeField (this);
         }
         this.startField = value;

         if (value != null)
         {
            value.addToHomeField (source);
         }
         changed = true;
      
      }
      return changed;
   }

   public HomeField withStartField (StartField value)
   {
      setStartField (value);
      return this;
   }

   public StartField getStartField ()
   {
      return this.startField;
   }

   public void removeYou()
   {
      this.setStartField (null);
      super.removeYou ();
   }
}


