package de.uks.pmws1112.hexentanz.model;

public class Witch
{
	public static final String PROPERTY_COLOR = "color";

   private String color;

   public void setColor (String value)
   {
      if (this.color == null || ! this.color.equals (value))
      {
         String oldValue = this.color;
         this.color = value;
      }
   }

   public Witch withColor (String value)
   {
      setColor (value);
      return this;
   }

   public String getColor ()
   {
      return this.color;
   }

   /**
    * <pre>
    *           0..*     field     0..1
    * Witch ------------------------- Field
    *           witches               field
    * </pre>
    */
   public static final String PROPERTY_FIELD = "field";

   private Field field;

   public boolean setField (Field value)
   {
      boolean changed = false;

      if (this.field != value)
      {
      
         Field oldValue = this.field;
         Witch source = this;
         if (this.field != null)
         {
            this.field = null;
            oldValue.removeFromWitches (this);
         }
         this.field = value;

         if (value != null)
         {
            value.addToWitches (source);
         }
         changed = true;
      
      }
      return changed;
   }

   public Witch withField (Field value)
   {
      setField (value);
      return this;
   }

   public Field getField ()
   {
      return this.field;
   }

   /**
    * <pre>
    *           0..*     witches     0..1
    * Witch ------------------------- Game
    *           witches               game
    * </pre>
    */
   public static final String PROPERTY_GAME = "game";

   private HexentanzGame game;

   public boolean setGame (HexentanzGame value)
   {
      boolean changed = false;

      if (this.game != value)
      {
      
         HexentanzGame oldValue = this.game;
         Witch source = this;
         if (this.game != null)
         {
            this.game = null;
            oldValue.removeFromWitches (source);
         }
         this.game = value;

         if (value != null)
         {
            value.addToWitches (source);
         }
         changed = true;
      
      }
      return changed;
   }

   public Witch withGame (HexentanzGame value)
   {
      setGame (value);
      return this;
   }

   public HexentanzGame getGame ()
   {
      return this.game;
   }

   public void removeYou()
   {
      this.setField (null);
      this.setGame (null);
   }
   
   public void move ()
   {
		//TODO nicht relevant fr Hausaufgabe 4
   }
}


